
Ruby - Bug #13267

ruby 2.4.0 i686-w64-mingw32 + boost compilation error

03/02/2017 08:33 AM - ntzrmtthihu777 (Marty Plummer)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby-2.4.0.tar.xz (mingw, can't run ruby

directly)

Backport: 2.2: DONE, 2.3: DONE, 2.4: DONE

Description

When building https://github.com/Ancurio/mkxp for windows (via i686-w64-mingw32), the following build error occurs:

In file included from /usr/i686-w64-mingw32/include/ruby-2.4.0/ruby/defines.h:243:0,

                 from /usr/i686-w64-mingw32/include/ruby-2.4.0/ruby/ruby.h:36,

                 from /usr/i686-w64-mingw32/include/ruby-2.4.0/ruby.h:33,

                 from mkxp/binding-mri/binding-util.h:25,

                 from mkxp/binding-mri/binding-mri.cpp:23:

/usr/i686-w64-mingw32/include/boost/functional/hash/detail/float_functions.hpp: In member function

 'Float boost::hash_detail::call_frexp<Float>::operator()(Float, int*) const':

/usr/i686-w64-mingw32/include/ruby-2.4.0/ruby/win32.h:759:23: error: expected unqualified-id befor

e '__extension__'

 #define frexp(_X, _Y) __extension__ ({\

                       ^

/usr/i686-w64-mingw32/include/ruby-2.4.0/ruby/win32.h:759:23: error: expected ';' before '__extens

ion__'

Associated revisions

Revision 85ac60cfd169a48658aa5f410c48d5878aca2227 - 03/03/2017 04:51 AM - nobu (Nobuyoshi Nakada)

broken mingw

configure.in: check whether frexp and modf are broken.

include/ruby/win32.h (frexp, modf): ignore bad declarations when

compiling as C++.  [ruby-core:79859] [Bug #13267]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 85ac60cf - 03/03/2017 04:51 AM - nobu (Nobuyoshi Nakada)

broken mingw

configure.in: check whether frexp and modf are broken.

include/ruby/win32.h (frexp, modf): ignore bad declarations when

compiling as C++.  [ruby-core:79859] [Bug #13267]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3e3b06b8c265b1012bed0bb76e299eb6e3698571 - 03/12/2017 04:21 PM - naruse (Yui NARUSE)

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57921 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 3e3b06b8 - 03/12/2017 04:21 PM - naruse (Yui NARUSE)

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57921 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9f853b2e1b874a7ae19c46cdbbec1aeb0adb3b4c - 03/25/2017 04:14 PM - U.Nakamura 

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58096 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9f853b2e - 03/25/2017 04:14 PM - U.Nakamura 

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58096 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ff6e8710ee889cc1f3803468d32ca6f26e937d0f - 03/27/2017 05:11 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58182 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ff6e8710 - 03/27/2017 05:11 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57762: [Backport #13267]

    broken mingw

    * configure.in: check whether frexp and modf are broken.

    * include/ruby/win32.h (frexp, modf): ignore bad declarations when

      compiling as C++.  [ruby-core:79859] [Bug #13267]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58182 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/02/2017 09:01 AM - ntzrmtthihu777 (Marty Plummer)

When compiling the same program, with the same libraries for linux, this issue does not arise.

#2 - 03/03/2017 04:51 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r57762.
broken mingw

configure.in: check whether frexp and modf are broken.

include/ruby/win32.h (frexp, modf): ignore bad declarations when

compiling as C++.  [ruby-core:79859] [Bug #13267]

#3 - 03/03/2017 07:17 AM - nobu (Nobuyoshi Nakada)

- Description updated

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED

#4 - 03/12/2017 04:21 PM - naruse (Yui NARUSE)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE

ruby_2_4 r57921 merged revision(s) 57762.

#5 - 03/25/2017 04:14 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE to 2.2: DONE, 2.3: REQUIRED, 2.4: DONE

ruby_2_2 r58096 merged revision(s) 57762.

#6 - 03/27/2017 05:11 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONE, 2.3: REQUIRED, 2.4: DONE to 2.2: DONE, 2.3: DONE, 2.4: DONE

ruby_2_3 r58182 merged revision(s) 57762.
